Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -2495,36 +3789,67 @@
     //////////////////////////////////////////////////////////////////////////////////
     {
+        PRINTF("--------------------------------------------\n");
+        PRINTF("  * CC_XCACHE_WRAPPER \"%s\" genMoore - Time = %d\n",name().c_str(),(uint32_t)m_cpt_total_cycles);
 
         // VCI initiator response
         switch ( r_cleanup_fsm.read() ) {
-
             case CLEANUP_IDLE:
                 p_vci_ini_c.rspack  = false;
-                p_vci_ini_c.cmdval  = r_icache_cleanup_req || r_dcache_cleanup_req;
-                if ( r_dcache_cleanup_req )
-                {
-                    p_vci_ini_c.address =  r_dcache_cleanup_line.read() * (m_dcache_words << 2);
-                    p_vci_ini_c.trdid   = TYPE_DATA_CLEANUP;
+                p_vci_ini_c.cmdval  = false;
+                p_vci_ini_c.address = 0;
+                p_vci_ini_c.wdata   = 0;
+                p_vci_ini_c.be      = 0;
+                p_vci_ini_c.plen    = 0;
+                p_vci_ini_c.cmd     = vci_param::CMD_WRITE;
+                p_vci_ini_c.trdid   = 0; 
+                p_vci_ini_c.pktid   = 0;
+                p_vci_ini_c.srcid   = 0;
+                p_vci_ini_c.cons    = false;
+                p_vci_ini_c.wrap    = false;
+                p_vci_ini_c.contig  = false;
+                p_vci_ini_c.clen    = 0;
+                p_vci_ini_c.cfixed  = false;
+                p_vci_ini_c.eop     = false;
+                break;
+
+            case CLEANUP_REQ:
+                {
+                addr_40 addr;
+                if (r_cleanup_icache)
+                {
+                    addr = r_icache_cleanup_line[r_cleanup_num_cache].read()<<m_icache_words_shift;
+                    set_num_icache(addr,r_cleanup_num_cache);
+
+                    PRINTF("      * <CLEANUP> icache             : %llx\n",(uint64_t)addr);
                 }
                 else
                 {
-                    p_vci_ini_c.address =  r_icache_cleanup_line.read() * (m_icache_words << 2); 
-                    p_vci_ini_c.trdid   = TYPE_INS_CLEANUP;
-                }
-                p_vci_ini_c.wdata  = 0;
-                p_vci_ini_c.be     = 0xF;
-                p_vci_ini_c.plen   = 4;
-                p_vci_ini_c.cmd    = vci_param::CMD_WRITE;
-                p_vci_ini_c.pktid  = 0;
-                p_vci_ini_c.srcid  = m_srcid_c;
-                p_vci_ini_c.cons   = false;
-                p_vci_ini_c.wrap   = false;
-                p_vci_ini_c.contig = false;
-                p_vci_ini_c.clen   = 0;
-                p_vci_ini_c.cfixed = false;
-                p_vci_ini_c.eop    = true;
+                    addr = r_dcache_cleanup_line[r_cleanup_num_cache].read()<<m_dcache_words_shift;
+                    set_num_dcache(addr,r_cleanup_num_cache);
+
+                    PRINTF("      * <CLEANUP> dcache             : %llx\n",(uint64_t)addr);
+                }
+
+                p_vci_ini_c.rspack  = false;
+                p_vci_ini_c.cmdval  = true;
+                p_vci_ini_c.address = addr;
+                p_vci_ini_c.wdata   = 0;
+                p_vci_ini_c.be      = 0xF;
+                p_vci_ini_c.plen    = 4;
+                p_vci_ini_c.cmd     = vci_param::CMD_WRITE;
+                p_vci_ini_c.trdid   = (r_cleanup_icache)?TYPE_INS_CLEANUP:TYPE_DATA_CLEANUP;
+                p_vci_ini_c.pktid   = (sc_dt::sc_uint<vci_param::P>)r_cleanup_num_cache;
+                p_vci_ini_c.srcid   = m_srcid_c;
+                p_vci_ini_c.cons    = false;
+                p_vci_ini_c.wrap    = false;
+                p_vci_ini_c.contig  = false;
+                p_vci_ini_c.clen    = 0;
+                p_vci_ini_c.cfixed  = false;
+                p_vci_ini_c.eop     = true;
+
                 break;
-
-           case CLEANUP_DCACHE:
+                }
+
+           case CLEANUP_RSP_DCACHE:
                 p_vci_ini_c.rspack  = true;
                 p_vci_ini_c.cmdval  = false;
@@ -2545,5 +3870,5 @@
                 break;
 
-           case CLEANUP_ICACHE:
+           case CLEANUP_RSP_ICACHE:
                 p_vci_ini_c.rspack  = true;
                 p_vci_ini_c.cmdval  = false;
@@ -2568,6 +3893,6 @@
 
         switch (r_vci_cmd_fsm.read() ) {
-
             case CMD_IDLE:
+                {
                 p_vci_ini_rw.cmdval  = false;
                 p_vci_ini_rw.address = 0;
@@ -2587,12 +3912,19 @@
 
                 break;
-
+                }
             case CMD_DATA_UNC:
+                {
                 p_vci_ini_rw.cmdval = true;
-                p_vci_ini_rw.address = (addr_40) r_dcache_addr_save.read() & ~0x3;
-                switch( r_dcache_type_save ) {
+
+                addr_40 addr = (addr_40) r_dcache_addr_save[r_vci_cmd_num_cache].read() & ~0x3;
+                set_num_dcache(addr,r_vci_cmd_num_cache);
+
+                PRINTF("      * <CMD> DATA_UNC   : %d - %llx\n",(uint32_t)r_vci_cmd_num_cache,(uint64_t)(addr));
+
+                p_vci_ini_rw.address = addr;
+                switch( r_dcache_type_save[r_vci_cmd_num_cache] ) {
                     case iss_t::DATA_READ:
                         p_vci_ini_rw.wdata = 0;
-                        p_vci_ini_rw.be  = r_dcache_be_save.read();
+                        p_vci_ini_rw.be  = r_dcache_be_save[r_vci_cmd_num_cache].read();
                         p_vci_ini_rw.cmd = vci_param::CMD_READ;
                         break;
@@ -2607,5 +3939,5 @@
                 p_vci_ini_rw.plen = 4;
                 p_vci_ini_rw.trdid  = TYPE_DATA_UNC;   // data cache uncached read
-                p_vci_ini_rw.pktid  = 0;
+                p_vci_ini_rw.pktid  = (sc_dt::sc_uint<vci_param::P>)r_vci_cmd_num_cache;
                 p_vci_ini_rw.srcid  = m_srcid_rw;
                 p_vci_ini_rw.cons   = false;
@@ -2617,8 +3949,15 @@
 
                 break;
-
+                }
             case CMD_DATA_SC:
+                {
                 p_vci_ini_rw.cmdval = true;
-                p_vci_ini_rw.address = (addr_40) r_dcache_addr_save.read() & ~0x3;
+
+                addr_40 addr = (addr_40) r_dcache_addr_save[r_vci_cmd_num_cache].read() & ~0x3;
+                set_num_dcache(addr,r_vci_cmd_num_cache);
+
+                PRINTF("      * <CMD> DATA_SC    : %d - %llx\n",(uint32_t)r_vci_cmd_num_cache,(uint64_t)(addr));
+
+                p_vci_ini_rw.address = addr;
                 if(r_vci_cmd_max.read() == 3){
                     ASSERT(false, "Not handled yet");
@@ -2626,8 +3965,8 @@
                     switch(r_vci_cmd_cpt.read()){
                         case 0:
-                            p_vci_ini_rw.wdata = (uint32_t)(r_dcache_ll_data.read() & 0xFFFFFFFF);
+                            p_vci_ini_rw.wdata = (uint32_t)(r_dcache_ll_data[r_vci_cmd_num_cache][r_dcache_num_cpu_save[r_vci_cmd_num_cache]].read() & 0xFFFFFFFF);
                             break;
                         case 1:
-                            p_vci_ini_rw.wdata = r_dcache_wdata_save.read();
+                            p_vci_ini_rw.wdata = r_dcache_wdata_save[r_vci_cmd_num_cache].read();
                             break;
                     }
@@ -2637,5 +3976,5 @@
                 p_vci_ini_rw.plen   = 4*(r_vci_cmd_max.read()+1);
                 p_vci_ini_rw.trdid  = TYPE_DATA_SC;   // data cache uncached read
-                p_vci_ini_rw.pktid  = 0;
+                p_vci_ini_rw.pktid  = (sc_dt::sc_uint<vci_param::P>)r_vci_cmd_num_cache;
                 p_vci_ini_rw.srcid  = m_srcid_rw;
                 p_vci_ini_rw.cons   = true;
@@ -2647,14 +3986,20 @@
 
                 break;
-
+                }
             case CMD_DATA_WRITE:
+                {
                 p_vci_ini_rw.cmdval  = true;
-                p_vci_ini_rw.address = r_wbuf.getAddress(r_vci_cmd_cpt)&~0x3;
-                p_vci_ini_rw.wdata   = r_wbuf.getData(r_vci_cmd_cpt);
-                p_vci_ini_rw.be      = r_wbuf.getBe(r_vci_cmd_cpt);
+
+                addr_40 addr       = (addr_40) r_wbuf[r_vci_cmd_num_cache]->getAddress(r_vci_cmd_cpt)&~0x3;
+
+                PRINTF("      * <CMD> DATA_WRITE : %d - %llx\n",(uint32_t)r_vci_cmd_num_cache,(uint64_t)(addr));
+
+                p_vci_ini_rw.address = addr;
+                p_vci_ini_rw.wdata   = r_wbuf[r_vci_cmd_num_cache]->getData(r_vci_cmd_cpt);
+                p_vci_ini_rw.be      = r_wbuf[r_vci_cmd_num_cache]->getBe(r_vci_cmd_cpt);
                 p_vci_ini_rw.plen    = (r_vci_cmd_max - r_vci_cmd_min + 1)<<2;
                 p_vci_ini_rw.cmd     = vci_param::CMD_WRITE;
-                p_vci_ini_rw.trdid   = r_wbuf.getIndex() + (1<<(vci_param::T-1));
-                p_vci_ini_rw.pktid   = 0;
+                p_vci_ini_rw.trdid   = r_wbuf[r_vci_cmd_num_cache]->getIndex() + (1<<(vci_param::T-1));
+                p_vci_ini_rw.pktid   = (sc_dt::sc_uint<vci_param::P>)r_vci_cmd_num_cache;
                 p_vci_ini_rw.srcid   = m_srcid_rw;
                 p_vci_ini_rw.cons    = false;
@@ -2666,13 +4011,20 @@
 
                 break;
-
+                }
             case CMD_DATA_MISS:
+                {
                 p_vci_ini_rw.cmdval = true;
-                p_vci_ini_rw.address = r_dcache_addr_save.read() & (addr_40) m_dcache_yzmask;
+
+                addr_40 addr = r_dcache_addr_save[r_vci_cmd_num_cache].read() & (addr_40) m_dcache_yzmask;
+                set_num_dcache(addr,r_vci_cmd_num_cache);
+
+                PRINTF("      * <CMD> DATA_MISS  : %d - %llx\n",(uint32_t)r_vci_cmd_num_cache,(uint64_t)(addr));
+
+                p_vci_ini_rw.address = addr;
                 p_vci_ini_rw.be     = 0xF;
                 p_vci_ini_rw.plen   = m_dcache_words << 2;
                 p_vci_ini_rw.cmd    = vci_param::CMD_READ;
                 p_vci_ini_rw.trdid  = TYPE_DATA_MISS;   // data cache cached read
-                p_vci_ini_rw.pktid  = 0;
+                p_vci_ini_rw.pktid  = (sc_dt::sc_uint<vci_param::P>)r_vci_cmd_num_cache;
                 p_vci_ini_rw.srcid  = m_srcid_rw;
                 p_vci_ini_rw.cons   = false;
@@ -2684,13 +4036,20 @@
 
                 break;
-
+                }
             case CMD_INS_MISS:
+                {
                 p_vci_ini_rw.cmdval = true;
-                p_vci_ini_rw.address = r_icache_addr_save.read() & (addr_40) m_icache_yzmask;
+
+                addr_40 addr = r_icache_addr_save[r_vci_cmd_num_cache].read() & (addr_40) m_icache_yzmask;
+                set_num_icache(addr,r_vci_cmd_num_cache);
+
+                PRINTF("      * <CMD> INS_MISS   : %d - %llx\n",(uint32_t)r_vci_cmd_num_cache,(uint64_t)(addr));
+
+                p_vci_ini_rw.address = addr;
                 p_vci_ini_rw.be     = 0xF;
                 p_vci_ini_rw.plen   = m_icache_words << 2;
                 p_vci_ini_rw.cmd    = vci_param::CMD_READ;
                 p_vci_ini_rw.trdid  = TYPE_INS_MISS;   // ins cache cached read
-                p_vci_ini_rw.pktid  = 0;
+                p_vci_ini_rw.pktid  = (sc_dt::sc_uint<vci_param::P>)r_vci_cmd_num_cache;
                 p_vci_ini_rw.srcid  = m_srcid_rw;
                 p_vci_ini_rw.cons   = false;
@@ -2702,13 +4061,20 @@
 
                 break;
-
+                }
             case CMD_INS_UNC:
+                {
                 p_vci_ini_rw.cmdval = true;
-                p_vci_ini_rw.address = r_icache_addr_save.read() & ~0x3;
+
+                addr_40 addr = r_icache_addr_save[r_vci_cmd_num_cache].read() & ~0x3;
+                set_num_icache(addr,r_vci_cmd_num_cache);
+
+                PRINTF("      * <CMD> INS_UNC    : %d - %llx\n",(uint32_t)r_vci_cmd_num_cache,(uint64_t)(addr));
+
+                p_vci_ini_rw.address = addr;
                 p_vci_ini_rw.be     = 0xF;
                 p_vci_ini_rw.plen   = 4;
                 p_vci_ini_rw.cmd    = vci_param::CMD_READ;
                 p_vci_ini_rw.trdid  = TYPE_INS_UNC;   // ins cache uncached read
-                p_vci_ini_rw.pktid  = 0;
+                p_vci_ini_rw.pktid  = (sc_dt::sc_uint<vci_param::P>)r_vci_cmd_num_cache;
                 p_vci_ini_rw.srcid  = m_srcid_rw;
                 p_vci_ini_rw.cons   = false;
@@ -2720,23 +4086,32 @@
 
                 break;
-
+                }
         } // end switch r_vci_cmd_fsm
 
-        bool ack;
-
-        switch (r_vci_rsp_fsm.read() ) {
-        case RSP_IDLE       : ack = false; break;
-        case RSP_DATA_WRITE : ack = true; break;
-        case RSP_INS_MISS   :
-        case RSP_INS_UNC    : ack = CACHE_MISS_BUF_RSP_ACK(i); break;
-        case RSP_DATA_MISS  :
-        case RSP_DATA_UNC   :
-        case RSP_DATA_SC    : ack = CACHE_MISS_BUF_RSP_ACK(d); break;
-        } // end switch r_vci_cmd_fsm
-
-        r_vci_rsp_ack       = ack;
-        p_vci_ini_rw.rspack = ack;
-        
+        {
+            bool ack;
+            
+            switch (r_vci_rsp_fsm.read() ) {
+            case RSP_DATA_WRITE : ack = true; break;
+            case RSP_INS_MISS   :
+            case RSP_INS_UNC    : ack = CACHE_MISS_BUF_RSP_ACK(i,r_vci_rsp_num_cache); break;
+            case RSP_DATA_MISS  :
+            case RSP_DATA_UNC   :
+            case RSP_DATA_SC    : ack = CACHE_MISS_BUF_RSP_ACK(d,r_vci_rsp_num_cache); break;
+                
+            case RSP_IDLE       :
+            default             : ack = false; break;
+                
+            } // end switch r_vci_cmd_fsm
+            
+            s_vci_rsp_ack       = ack;
+            p_vci_ini_rw.rspack = ack;
+
+            PRINTF("      * <RSP> rspack : %d\n", ack);
+        }
+
         // VCI_TGT
+
+        // PRINTF("      * <TGT> srcid : %d\n", r_tgt_srcid.read());
 
         switch ( r_vci_tgt_fsm.read() ) {
@@ -2750,36 +4125,68 @@
 
             case TGT_RSP_BROADCAST:
-                p_vci_tgt.cmdack  = false;
-                p_vci_tgt.rspval  = not r_tgt_icache_req.read() and not r_tgt_dcache_req.read() and ( r_tgt_icache_rsp | r_tgt_dcache_rsp );
-                p_vci_tgt.rsrcid  = r_tgt_srcid.read();
-                p_vci_tgt.rpktid  = r_tgt_pktid.read();
-                p_vci_tgt.rtrdid  = r_tgt_trdid.read();
-                p_vci_tgt.rdata   = 0;
-                p_vci_tgt.rerror  = 0x2 & ( (1 << vci_param::E) - 1); // Write OK
-                p_vci_tgt.reop    = true;
-                break;
-
+                {
+                    bool tgt_icache_req;
+                    bool tgt_icache_rsp;
+
+#if   (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+                    tgt_icache_req = r_tgt_icache_req[r_tgt_num_cache].read();
+                    tgt_icache_rsp = r_tgt_icache_rsp[r_tgt_num_cache].read();
+#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
+                    tgt_icache_req = false;
+                    tgt_icache_rsp = false;
+                    for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                    {
+                        tgt_icache_req |= r_tgt_icache_req[num_cache].read();
+                        tgt_icache_rsp |= r_tgt_icache_rsp[num_cache].read();
+                    }
+#endif
+
+                    bool rspval = ((not tgt_icache_req and not r_tgt_dcache_req[r_tgt_num_cache].read()) 
+                                   and (tgt_icache_rsp | r_tgt_dcache_rsp[r_tgt_num_cache]));
+
+                    PRINTF("      * <TGT> RSP_BROADCAST : rspval : %d (i %d %d, d %d %d)\n",rspval,tgt_icache_req,tgt_icache_rsp, r_tgt_dcache_req[r_tgt_num_cache].read(), r_tgt_dcache_rsp[r_tgt_num_cache].read());
+                    
+                    p_vci_tgt.cmdack  = false;
+                    p_vci_tgt.rspval  = rspval;
+                    p_vci_tgt.rsrcid  = r_tgt_srcid.read();
+                    p_vci_tgt.rpktid  = r_tgt_pktid.read();
+                    p_vci_tgt.rtrdid  = r_tgt_trdid.read();
+                    p_vci_tgt.rdata   = 0;
+                    p_vci_tgt.rerror  = 0x2 & ( (1 << vci_param::E) - 1); // Write OK
+                    p_vci_tgt.reop    = true;
+                    break;
+                }
             case TGT_RSP_ICACHE:
-                p_vci_tgt.cmdack  = false;
-                p_vci_tgt.rspval  = not r_tgt_icache_req.read() and r_tgt_icache_rsp.read();
-                p_vci_tgt.rsrcid  = r_tgt_srcid.read();
-                p_vci_tgt.rpktid  = r_tgt_pktid.read();
-                p_vci_tgt.rtrdid  = r_tgt_trdid.read();
-                p_vci_tgt.rdata   = 0;
-                p_vci_tgt.rerror  = 0x2 & ( (1 << vci_param::E) - 1); // Write OK
-                p_vci_tgt.reop    = true;
-                break;
-
+                {
+                    bool rspval = not r_tgt_icache_req[r_tgt_num_cache].read() and r_tgt_icache_rsp[r_tgt_num_cache].read();
+
+                    PRINTF("      * <TGT> RSP_ICACHE : rspval : %d\n",rspval);
+
+                    p_vci_tgt.cmdack  = false;
+                    p_vci_tgt.rspval  = rspval;
+                    p_vci_tgt.rsrcid  = r_tgt_srcid.read();
+                    p_vci_tgt.rpktid  = r_tgt_pktid.read();
+                    p_vci_tgt.rtrdid  = r_tgt_trdid.read();
+                    p_vci_tgt.rdata   = 0;
+                    p_vci_tgt.rerror  = 0x2 & ( (1 << vci_param::E) - 1); // Write OK
+                    p_vci_tgt.reop    = true;
+                    break;
+                }
             case TGT_RSP_DCACHE:
-                p_vci_tgt.cmdack  = false;
-                p_vci_tgt.rspval  = not r_tgt_dcache_req.read() and r_tgt_dcache_rsp.read();
-                p_vci_tgt.rsrcid  = r_tgt_srcid.read();
-                p_vci_tgt.rpktid  = r_tgt_pktid.read();
-                p_vci_tgt.rtrdid  = r_tgt_trdid.read();
-                p_vci_tgt.rdata   = 0;
-                p_vci_tgt.rerror  = 0x2 & ( (1 << vci_param::E) - 1); // Write OK
-                p_vci_tgt.reop    = true;
-                break;
-
+                {
+                    bool rspval = not r_tgt_dcache_req[r_tgt_num_cache].read() and r_tgt_dcache_rsp[r_tgt_num_cache].read();
+
+                    PRINTF("      * <TGT> RSP_DCACHE : rspval : %d\n",rspval);
+                    
+                    p_vci_tgt.cmdack  = false;
+                    p_vci_tgt.rspval  = rspval;
+                    p_vci_tgt.rsrcid  = r_tgt_srcid.read();
+                    p_vci_tgt.rpktid  = r_tgt_pktid.read();
+                    p_vci_tgt.rtrdid  = r_tgt_trdid.read();
+                    p_vci_tgt.rdata   = 0;
+                    p_vci_tgt.rerror  = 0x2 & ( (1 << vci_param::E) - 1); // Write OK
+                    p_vci_tgt.reop    = true;
+                    break;
+                }
             case TGT_REQ_BROADCAST:
             case TGT_REQ_ICACHE:
@@ -2814,4 +4221,43 @@
     }
 
+    //////////////////////////////////////////////////////////////////////////////////
+    tmpl(uint32_t)::get_num_cache(addr_40 & addr)
+    //////////////////////////////////////////////////////////////////////////////////
+    {
+        uint32_t num_cache = get_num_cache_only(addr);
+
+        addr = ((addr&m_num_cache_LSB_mask) | // keep LSB
+                ((addr>>m_num_cache_MSB)<<m_num_cache_LSB)); // set MSB
+
+        return num_cache;
+    }
+
+    //////////////////////////////////////////////////////////////////////////////////
+    tmpl(uint32_t)::get_num_cache_only(addr_40 addr)
+    //////////////////////////////////////////////////////////////////////////////////
+    {
+        return (addr>>m_num_cache_LSB)&m_num_cache_mask;
+    }
+
+    //////////////////////////////////////////////////////////////////////////////////
+    tmpl(void)::set_num_cache(addr_40 & addr, uint32_t num_cache)
+    //////////////////////////////////////////////////////////////////////////////////
+    {
+        addr = ((addr&m_num_cache_LSB_mask) | // keep LSB
+                ((addr_40)num_cache << m_num_cache_LSB) |
+                ((addr>>m_num_cache_LSB)<<m_num_cache_MSB)); // set MSB
+    }
+
+    //////////////////////////////////////////////////////////////////////////////////
+    // fixme : mettre le type addr_40
+    tmpl(sc_dt::sc_uint<40>)::set_num_cache_only(addr_40 addr, uint32_t num_cache) 
+    //////////////////////////////////////////////////////////////////////////////////
+    {
+        return ((addr&m_num_cache_LSB_mask) | // keep LSB
+                ((addr_40)num_cache << m_num_cache_LSB) |
+                ((addr>>m_num_cache_LSB)<<m_num_cache_MSB)); // set MSB
+    }
+
+
 }} // end namespace
 
